library CheckPIDDll;


uses
  SysUtils,
  Classes,
  Windows,
  JwaMsi,
  jwaMSIQuery;

{$R *.res}
function VerifyPID(hInstall: MSIHandle): Integer; stdcall;
var
  sPidKey: PChar;
  dwBuffer: Cardinal;
  sKey: string;
  n1,n2,n3: Integer;
begin
  dwBuffer := MAX_PATH;
  sPidKey := strAlloc(MAX_PATH);
  try
    // Get the PIDKEY property
    MsiGetProperty(hInstall, 'PIDKEY', sPidKey, dwBuffer);
    //check PIDKEY here
    sKey := string(sPidKey);
    n1 := StrToInt(sKey[3]);
    n2 := StrToInt(sKey[11]);
    n3 := (n1 + n2) mod 3;
    if (n3 = 0) and (n1 <> n2) then
     Begin
      MsiSetProperty(hInstall, 'PIDCHECK', 'TRUE');//PIDKEY passes check
     End
    else
     Begin
      MsiSetProperty(hInstall, 'PIDCHECK', 'FALSE');
      MessageBox(0, PChar('serial number is not valid.'), PChar('Installer'), MB_OK or MB_ICONINFORMATION);
     End;
  finally
    StrDispose(sPidKey);
  end;
  result := 0;
end;

exports
  VerifyPID;

begin
end.

